/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.   *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.frameworks.portletcontainer.portalframework;

import javax.portlet.Event;

/**
 * Created by The eXo Platform SAS  .
 *
 * @author <a href="mailto:roman.pedchenko@exoplatform.com.ua">Roman Pedchenko</a>
 * @version $Id$
 */

/**
 * Internal class that defines event + its target portlet each event before processing is splitted
 * into a number of EventInfo instances -- one instance per target portlet.
 *
 */
public class EventInfo {

  /**
   * Formed event.
   */
  private Event event;

  /**
   * Target portlet which the event has to be delivered to.
   */
  private String target;

  /**
   * Default constructor.
   */
  public EventInfo() {
  }

  /**
   * Normal constructor.
   *
   * @param event event to deliver
   * @param target target portlet name to deliver the event to
   */
  public EventInfo(final Event event, final String target) {
    this.event = event;
    this.target = target;
  }

  /**
   * Event field getter.
   *
   * @return event itself
   */
  public final Event getEvent() {
    return event;
  }

  /**
   * Event field setter.
   *
   * @param event event to set
   */
  public final void setEvent(final Event event) {
    this.event = event;
  }

  /**
   * Target field getter.
   *
   * @return target portlet name
   */
  public final String getTarget() {
    return target;
  }

  /**
   * Target field setter.
   *
   * @param target target portlet name to set
   */
  public final void setTarget(final String target) {
    this.target = target;
  }

}
