package org.exoplatform.frameworks.portletcontainer.portalframework.test;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.ArrayList;

import javax.portlet.WindowState;
import javax.portlet.PortletMode;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
import org.exoplatform.services.portletcontainer.pci.ExoWindowID;
import org.exoplatform.services.portletcontainer.pci.RenderOutput;
import org.exoplatform.services.portletcontainer.pci.*;
import org.exoplatform.frameworks.portletcontainer.portalframework.PortletInfo;

import org.exoplatform.services.portletcontainer.PortletContainerException;

/**
 * Created by The eXo Platform SAS  2007 .
 *
 * @author Max Shaposhnik
 * @version $Id$
 */



public class TestIncludingModeAndState extends BaseTest {
  
  public TestIncludingModeAndState(String s) {
    super(s);
  }
  
  private static Log log = ExoLogger.getLogger("org.exoplatform.services.portletcontainer.portalframework.test.TestIncludingModeAndState");
  
  public void testIncludingModeAndState() throws PortletContainerException {
    
    /**
     * PLT 7.1.2
     * If the portlet mode is not set for a URL, 
     * it must have the portlet mode of the current request as default
     * If the window state is not set for a URL, it must have the 
     * window state of the current request as default
     */
    
    try{
    
    log.info("testIncludingModeAndState...");
    String markupType = "text/html";
    ArrayList requestedPortlets = new ArrayList();
    requestedPortlets.add("war_template/PortletToTestIncludingModeAndState");
    
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());
    request.setParameter("portal:action", "render");
    request.setParameter("portal:windowState", "minimized");
    request.setParameter("portal:portletMode", "edit");
    request.setParameter("portal:componentId", "war_template/PortletToTestIncludingModeAndState");
    
    ArrayList resultList  = framework.processRequest(mockServletContext, request, response,
        markupType, requestedPortlets);

    
    MockServletRequest request2 = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response2 = new MockServletResponse(new EmptyResponse());
    request2.setParameter("portal:action", "render");
    //request2.setParameter("portal:windowState", "minimized");
    //request2.setParameter("portal:portletMode", "edit");
    request2.setParameter("portal:componentId", "war_template/PortletToTestIncludingModeAndState");
    
    ArrayList resultList2  = framework.processRequest(mockServletContext, request2, response2,
        markupType, requestedPortlets);
    
    PortletInfo pInfo = (PortletInfo)resultList2.get(0);
    assertTrue(pInfo.getOut().indexOf("minimized") > -1);
    assertTrue(pInfo.getOut().indexOf("edit") > -1);
    
    } catch (Exception e) {
      e.printStackTrace();
    }
    
  }
  
}
