package org.exoplatform.frameworks.portletcontainer.portalframework.test;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.ArrayList;

import javax.portlet.WindowState;
import javax.portlet.PortletMode;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
import org.exoplatform.services.portletcontainer.pci.ExoWindowID;
import org.exoplatform.services.portletcontainer.pci.RenderOutput;
import org.exoplatform.services.portletcontainer.pci.*;
import org.exoplatform.frameworks.portletcontainer.portalframework.PortletInfo;

import org.exoplatform.services.portletcontainer.PortletContainerException;


/**
 * Created by The eXo Platform SAS  2007 .
 *
 * @author Max Shaposhnik
 * @version $Id$
 */


public class TestRenderParameters extends BaseTest {
  
  
  public TestRenderParameters(String s) {
    super(s);
  }

  
  private static Log log = ExoLogger.getLogger("org.exoplatform.services.portletcontainer.portalframework.test.testRenderParameters");
  
  
  public void testRenderParameters() throws PortletContainerException {
     
     /** PLT 11.1.1.2
      * If a portlet wants to do that in either the processAction or processEvent methods, it 
      * must use the  setRenderParameter or  setRenderParameters  methods of the 
      * StateAwareResponse object within the processAction or processEvent call. The set 
      * render parameters must be provided to the processEvent and render calls of at least 
      * the current client request.
      */
   
    log.info("testRenderParameters...");
    String markupType = "text/html";
    ArrayList requestedPortlets = new ArrayList();
    requestedPortlets.add("war_template/PortletToTestParametersIsolation");
    
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());
    request.setParameter("portal:action", "action");
    request.setParameter("portal:windowState", "normal");
    request.setParameter("portal:portletMode", "view");
    request.setParameter("portal:componentId", "war_template/PortletToTestRenderParameters");
    
    ArrayList resultList  = framework.processRequest(mockServletContext, request, response,
        markupType, requestedPortlets);
    
    PortletInfo pInfo = (PortletInfo)resultList.get(1);
    assertTrue(pInfo.getOut().indexOf("OK") > -1);
    log.info("Done.");
  }
  

}
