/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.portletcontainer.test.portlet2;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.Map;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.PortletURL;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.ResourceURL;

/**
 * @author <a href="mailto:roman.pedchenko@exoplatform.com.ua">Roman Pedchenko</a>
 * @version $Id: $
 */

public class TestUrlListenersPortlet2 extends GenericPortlet {

  public void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {
    response.setContentType("text/html");
    PrintWriter w = response.getWriter();
    w.println("<table width=\"100%\" border=\"1\">");
    w.println("<tr><th colspan=\"2\">Render parameters</th></tr>");
    w.println("<tr><th>parameter</th><th>value</th></tr>");
    Map<String, String[]> params = request.getParameterMap();
    Iterator<String> names = params.keySet().iterator();
    while (names.hasNext()) {
      String name = names.next();
      w.println("<tr><td>" + name + "</td>");
      w.println("<td>" + request.getParameter(name) + "</td></tr>");
    }
    w.println("</table>");

    PortletURL url = response.createRenderURL();
    url.setParameter("param", "val");
    w.println("<a href=\"");
    url.write(w);
    w.println("\">render url</a>");
    url = response.createActionURL();
    url.setParameter("param", "val");
    w.println("<a href=\"");
    url.write(w);
    w.println("\">action url</a>");
  }

  public void processAction(ActionRequest request, ActionResponse response) throws PortletException, IOException {
    Map<String, String[]> params = request.getParameterMap();
    Iterator<String> names = params.keySet().iterator();
    while (names.hasNext()) {
      String name = names.next();
      response.setRenderParameter("fromAction_" + name, request.getParameter(name));
    }
  }

}
