/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.portletcontainer.test.filters;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.exoplatform.frameworks.portletcontainer.portalframework.PortletInfo;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SAS  .
 *
 * @author <a href="mailto:roman.pedchenko@exoplatform.com.ua">Roman Pedchenko</a>
 * @version $Id$
 */
public class PortalServlet extends HttpServlet {
  
  private Log log;

  /**
   * Serves http request. Renders portal page.
   *
   * @param request http request
   * @param response http response
   * @throws IOException declared by superclass
   * @throws ServletException declared by superclass
   */
  public void service(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {

    try {
      this.log = ExoLogger.getLogger(getClass());
      HttpSession session = request.getSession();
      byte[] resource = (byte[]) session.getAttribute("resource");
      if (resource != null) {
        String cntType = (String) session.getAttribute("resourceType");
        if (cntType != null)
          response.setContentType(cntType);
        else
          response.setContentType("text/html");
        OutputStream w = response.getOutputStream();
        w.write(resource);
        w.close();
        session.removeAttribute("resource");
        session.removeAttribute("resourceType");
        return;
      }

      response.setContentType("text/html;charset=UTF-8");
      PrintWriter w = response.getWriter();

      if (session.getAttribute("portletName") != null) {
        // especiallty for TCK tests
        ArrayList<PortletInfo> portletinfos = (ArrayList) session.getAttribute("portletinfos");
        for (Iterator<PortletInfo> i = portletinfos.iterator(); i.hasNext();) {
          PortletInfo pinf = i.next();
          w.println(pinf.getOut());
        }
        return;
      }

      w.println("<html>");
        w.println("<head>");
          w.println("<meta http-equiv=\"Content-Type\" content=\"text/html;charset=UTF-8\">");
          w.println("<title>Portlet rendering</title>");
        w.println("</head>");
      w.println("<body width='100%'>");
      w.println("<h1>Portlets</h1>");

      ArrayList portletinfos = (ArrayList<PortletInfo>) session.getAttribute("portletinfos");
      if (request.getParameter("fis") != null) {
        //submitted form
        session.removeAttribute("myatr");
        ArrayList<String> myatr = new ArrayList<String>();
        try {
          if (portletinfos != null) {
            for (int i = 1; i <= portletinfos.size(); i++) {
              if (request.getParameter("n"+i+"n") != null)  {
                if (request.getParameter("n"+i+"n").equals("on")){
                  // is on
                  myatr.add("checked");
                } else {
                  //isn't on
                  myatr.add("");
                }
              } else {
                //is null
                myatr.add("");
              }
            }
          }
        } catch (Exception e1) {
          e1.printStackTrace();
          session.setAttribute("myatr", null);
        }
        session.setAttribute("myatr",myatr);
      } else {
        //not submitted form
        ArrayList<String> myatr0 = (ArrayList) session.getAttribute("myatr");
        if (myatr0 != null) {
          //there is session
          // all ok
        } else {
          //there isn't session
          // haven't session myatr
          ArrayList<String> myatr = new ArrayList<String>();
          try {
            if (portletinfos != null) {
              for (int i = 1; i <= portletinfos.size(); i++) {
                myatr.add("");
              }
            }
          } catch (Exception e1) {
            e1.printStackTrace();
            session.setAttribute("myatr", null);
          }
          session.setAttribute("myatr",myatr);
        }
      }

      ArrayList myatr = (ArrayList) session.getAttribute("myatr");
      try {
        if (portletinfos != null) {
          w.println("<form method='POST' name='checkPortlet' action='.'>");
          w.println("<input type='hidden' name='fis' id='fis' value='yes'>");
            w.println("<table width='100%' border='1'>");
              w.println("<tr><th valign='center' bgcolor='#D0F0D0' colspan='4'><h1>"
                  + "Please, select some of the following portlets</h1></th></tr>");
              w.println("<tr><td align='center'>Checked</td>");
                w.println("<td align='center'>Num</td>");
                w.println("<td align='center'>Portlet Id</td>");
              w.println("<td align='center'>Portlet Name</td></tr>");
          int i2 = 0;
          for (Iterator i = portletinfos.iterator(); i.hasNext();) {
            PortletInfo pinf = (PortletInfo) i.next();
              String title2 = pinf.getTitle();
              String id2 = pinf.getPortlet();
              String myatr2str = (String) myatr.get(i2++);
              w.println("<tr><td align='center'>");
                w.println("<input type='checkbox' name='n"+i2+"n' ID='n"+i2+"n' " + myatr2str
                    + " onClick='checkPortlet.submit()'>");
                w.println("</td><td align='center'>"+i2+"</td><td valign='center' bgcolor=''>"+id2+"</td>");
              w.println("<td valign='center' bgcolor=''>"+title2+"</td></tr>");
            }
            w.println("</table>");
          w.println("</form>");
        } else {
          w.println("<table width='100%' border='1'><tr><td>There's no portlet data to show</td></tr></table>");
        }
      } catch (Exception e1) {
        e1.printStackTrace();
      }

      String reqURL = new String(request.getRequestURL() + "?");
      String reqContextPath = new String(request.getContextPath().substring(1, request.getContextPath().length())
          + ":");

      try {
        if (portletinfos != null) {
          int i2 = 0;
          for (Iterator<PortletInfo> i = portletinfos.iterator(); i.hasNext();) {
            PortletInfo pinf = i.next();
            String myatrstr = (String) myatr.get(i2++);
            if (myatrstr=="checked") {
              String title = pinf.getTitle();
              String hs = pinf.getOut();
              ArrayList<String> mymodes = pinf.getModes();
              ArrayList<String> mystates = pinf.getStates();
              String portlet = pinf.getPortlet();
              w.println("<table width='100%' border='1'>");
                w.println("<tr><th valign='center' bgcolor='#D0F0D0'><h1><div id=\"p" + pinf.getWid() + "title\">"
                    + title + "</div></h1>");
              String resMode = reqURL;
              resMode += reqContextPath + "componentId=" + portlet;
              resMode += "&" + reqContextPath + "type=action";
              resMode += "&" + reqContextPath + "isSecure=true";
              if (mymodes!= null)
              for (int j = 0; j < mymodes.size(); j++) {
                w.println("<a href='" + resMode + "&" + reqContextPath + "portletMode=" + mymodes.get(j) + "'>"
                    + mymodes.get(j) + "</a>");
              }
                w.println("<br>");
              if (mystates!= null)
                for (int k = 0; k < mystates.size(); k++) {
                  w.println("<a href='" + resMode + "&" + reqContextPath + "windowState=" + mystates.get(k) + "'>"
                      + mystates.get(k) + "</a>");
                }
                w.println("</th></tr>");
                w.println("<tr><td><div id=\"p" + pinf.getWid() + "content\">" + hs + "</div></td></tr>");
              w.println("</table>");
            }
          }
        } else {
          w.println("<table width='100%' border='1'><tr><th>There's no portlet data to show</th></tr></table>");
        }
      } catch (Exception e1) {
        e1.printStackTrace();
      }
      w.println("</body>");
      w.println("</html>");
      System.out.println("-------------------------------------------------------------");

    } catch (Exception e) {
      e.printStackTrace();
    }
  }

}
