/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

package org.exoplatform.services.portletcontainer.pci;

/**
 * @author: Roman Pedchenko
 * @email:  roman.pedchenko@exoplatform.com.ua
 * @version: $Id$
 */

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.portlet.Event;
import javax.portlet.PortletMode;
import javax.portlet.WindowState;
import javax.xml.namespace.QName;

public class EventOutput extends Output {
  
  private List<Event> events = new ArrayList<Event>();
  private PortletMode nextMode;
  private WindowState nextState;
  private Map renderParameters = new HashMap();
  
  public List<Event> getEvents() {
    return events;
  }
  
  public Event getEventByName(String eventName) {
    for (Event event : events) {
      if (event.getName().equals(eventName))
        return event;
    }
    return null;
  }
  
  public Serializable getEventValueByName(String eventName) {
    Event event = getEventByName(eventName);
    if (event != null)
      return event.getValue();
    return null;
  }

  public void setEvents(List<Event> events) {
    this.events = events;
  }

  public void setEvent(QName name, Serializable event) {
    events.add(new EventImpl(name, event));
  }
  
  public PortletMode getNextMode() {
    return nextMode;
  }

  public void setNextMode(PortletMode nextMode) {
    this.nextMode = nextMode;
  }

  public WindowState getNextState() {
    return nextState;
  }

  public void setNextState(WindowState nextState) {
    this.nextState = nextState;
  }

  public Map getRenderParameters() {
    return renderParameters;
  }

  public void setRenderParameters(Map renderParameters) {
    this.renderParameters = renderParameters;
  }

  public void setRenderParameter(String key, String value) {
    renderParameters.put(key, new String[] {value});
  }

  public void setRenderParameters(String key, String[] values) {
    renderParameters.put(key, values);
  }

}