/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.plugins.pc.aop;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.Portlet;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.EventRequest;
import javax.portlet.EventResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
//import javax.portlet.FragmentRequest;
//import javax.portlet.FragmentResponse;

/**
 * Created by The eXo Platform SAS 
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Sep 17, 2005
 */
public class PortletCommandChain {
  private BaseCommandUnit commands_ ;
   
  public void addCommand(BaseCommandUnit  command) {
    if(commands_ == null) commands_ = command ;
    else commands_.addExecutionUnit(command) ;
  } 
  
  public  void doRender(Portlet portlet, RenderRequest req, RenderResponse res) throws Throwable {
    RenderExecutionContext context = new RenderExecutionContext(portlet, req, res) ;
    context.setCurrentExecutionUnit(commands_) ;
    context.execute() ;
  }
  
  public  void doProcessAction(Portlet portlet, ActionRequest req, ActionResponse res) throws Throwable {
    ActionExecutionContext context = new ActionExecutionContext(portlet, req, res) ;
    context.setCurrentExecutionUnit(commands_) ;
    context.execute() ;
  }
  
  public  void doProcessEvent(Portlet portlet, EventRequest req, EventResponse res) throws Throwable {
    EventExecutionContext context = new EventExecutionContext(portlet, req, res) ;
    context.setCurrentExecutionUnit(commands_) ;
    context.execute() ;
  }
  
  public  void doServeResource(Portlet portlet, ResourceRequest req, ResourceResponse res) throws Throwable {
    ResourceExecutionContext context = new ResourceExecutionContext(portlet, req, res) ;
    context.setCurrentExecutionUnit(commands_) ;
    context.execute() ;
  }
  
//  public  void doServeFragment(Portlet portlet, FragmentRequest req, FragmentResponse res) throws Throwable {
//    FragmentExecutionContext context = new FragmentExecutionContext(portlet, req, res) ;
//    context.setCurrentExecutionUnit(commands_) ;
//    context.execute() ;
//  }
  
}
