package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;

/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SAS 
 * Author : Roman Pedchenko <roman.pedchenko@exoplatform.com.ua>
 */

import javax.portlet.CacheControl;
import javax.portlet.RenderResponse;

public class CacheControlImp implements CacheControl {

  private MimeResponseImp resp;
  
  public CacheControlImp(MimeResponseImp resp) {
    this.resp = resp;
  }

  public int getExpirationTime() {
    return Integer.parseInt(resp.getProperty(RenderResponse.EXPIRATION_CACHE));
  }

  public void setExpirationTime(int time) {
    resp.setProperty(RenderResponse.EXPIRATION_CACHE, String.valueOf(time));
  }

  public boolean isPublicScope() {
    return resp.getProperty(RenderResponse.CACHE_SCOPE).equals(RenderResponse.PUBLIC_SCOPE);
  }

  public void setPublicScope(boolean publicScope) {
    if (publicScope)
      resp.setProperty(RenderResponse.CACHE_SCOPE, RenderResponse.PUBLIC_SCOPE);
    else
      resp.setProperty(RenderResponse.CACHE_SCOPE, RenderResponse.PRIVATE_SCOPE);
  }

  public String getETag() {
    return resp.getProperty(RenderResponse.ETAG);
  }

  public void setETag(String token) {
    resp.setProperty(RenderResponse.ETAG, token);
  }

  public boolean useCachedContent() {
    return resp.getProperty(RenderResponse.USE_CACHED_CONTENT) != null;
  }

  public void setUseCachedContent(boolean useCachedContent) {
    if (useCachedContent)
      resp.setProperty(RenderResponse.USE_CACHED_CONTENT, "");
    else
      resp.removeProperty(RenderResponse.USE_CACHED_CONTENT);
  }

}
