/**
 * Copyright 2001-2007 The eXo Platform SAS  All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SAS 
 * Author : Roman Pedchenko <roman.pedchenko@exoplatform.com.ua>
 */
package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;

import java.util.*;

import javax.portlet.PortalContext;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.services.portletcontainer.pci.*;
import org.exoplatform.services.portletcontainer.pci.model.*;

public class ResponseContext {

  private HttpServletResponse httpServletResponse_;
  private ExoContainer cont_;
  private String windowID_;
  private Input input_;
  private Portlet portletDatas_;
  private boolean isSecure_;
  private Collection supportedContents_;
  private Enumeration windowStates_;
  private List customWindowState_;
  private Output output_;
  private PortalContext portalContext_;
  
  public ResponseContext(HttpServletResponse httpServletResponse,
                         ExoContainer cont,
                         String windowID,
                         Input input,
                         Portlet portletDatas,
                         boolean isSecure,
                         Collection supportedContents,
                         Enumeration windowStates,
                         List customWindowState,
                         Output output,
                         PortalContext portalContext) {
    this.httpServletResponse_ = httpServletResponse;
		this.cont_ = cont;
		this.windowID_ = windowID;
		this.input_ = input;
		this.portletDatas_ = portletDatas;
		this.isSecure_ = isSecure;
		this.supportedContents_ = supportedContents;
		this.windowStates_ = windowStates;
    this.customWindowState_ = customWindowState;
    this.output_ = output;
    this.portalContext_ = portalContext;
	}

  public HttpServletResponse getHttpServletResponse() {
    return httpServletResponse_;
  }
  
  public ExoContainer getCont() {
    return cont_;
  }
  
  public String getWindowID() {
    return windowID_;
  }
  
  public Input getInput() {
    return input_;
  }
  
  public Portlet getPortletDatas() {
    return portletDatas_;
  }
  
  public boolean isSecure() {
    return isSecure_;
  }
  
  public Collection getSupportedContents() {
    return supportedContents_;
  }
  
  public Enumeration getWindowStates() {
    return windowStates_;
  }
  
  public List getCustomWindowState() {
    return customWindowState_;
  }
  
  public Output getOutput() {
    return output_;
  }
  
  public PortalContext getPortalContext() {
    return portalContext_;
  }

}
