package org.exoplatform.services.portletcontainer.imp.Portlet286;

import javax.portlet.Event;
import javax.portlet.PortletMode;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.namespace.QName;

import org.exoplatform.services.portletcontainer.PortletContainerException;
import org.exoplatform.services.portletcontainer.imp.EmptyResponse;
import org.exoplatform.services.portletcontainer.pci.ExoWindowID;
import org.exoplatform.services.portletcontainer.pci.EventOutput;
import org.exoplatform.services.portletcontainer.pci.EventImpl;
import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.io.*;
import java.lang.Thread;
import java.util.Iterator;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

/**
 * @author Max Shaposhnik
 * PLT 15.2.6
 * If a permanent unavailability is indicated by the UnavailableException, the portlet 
 * container must remove the portlet from service immediately, call the portlets destroy 
 * method, and release the portlet object.   A portlet that throws a permanent 
 */
  

  public class TestPortletUnavailable  extends BaseTest2 {
  
  public TestPortletUnavailable(String s) {
    super(s);
  }
  
  
  private static Log log = ExoLogger.getLogger("org.exoplatform.services.portletcontainer.imp.Portlet286.TestPortletUnavailable");
  
  
  public void testPortletUnavailable() throws PortletContainerException {
    log.info("testResourceURL...");
    
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());    
    ((ExoWindowID)eventInput.getInternalWindowID()).setPortletName("PortletToTestPortletUnavailable");
    eventInput.setPortletMode(new PortletMode("view"));
    Event event = new EventImpl(new QName("MyEventProc"), new String("event-value"));
    eventInput.setEvent(event);
    
    EventOutput eo = portletContainer.processEvent(request, response, eventInput);
    
  try {
  Thread.sleep(500);
  }
  catch (InterruptedException e) {
  }
    assertFalse(portletMonitor.isAvailable("war_template2",
        "PortletToTestPortletUnavailable",
        System.currentTimeMillis()));
    log.info("Done.");
  }
    
  
  

}
