package org.exoplatform.services.portletcontainer.imp.Portlet286;

import javax.portlet.PortletMode;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.exoplatform.services.portletcontainer.PortletContainerException;
import org.exoplatform.services.portletcontainer.imp.EmptyResponse;
import org.exoplatform.services.portletcontainer.pci.ExoWindowID;
import org.exoplatform.services.portletcontainer.pci.RenderOutput;
import org.exoplatform.services.portletcontainer.pci.ResourceOutput;
import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.io.*;
import java.util.*;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

/**
 * @author Max Shaposhnik
 * PLT 13.6
 * The portlet can create resource URLs pointing back to itself via the createResourceURL 
 * PortletResponse. When an end user invokes such a resource 
 * method on the URL the portlet container must call the serveResource method of the 
 * portlet or return a valid cached result for this resource URL
 */
  
public class TestResourceURL extends BaseTest2 {
  
  public TestResourceURL(String s) {
    super(s);
  }

  private static Log log = ExoLogger.getLogger("org.exoplatform.services.portletcontainer.imp.Portlet286.TestResourceURL");
  
  
  public void testResourceURL() throws PortletContainerException {
    log.info("testResourceURL...");
    
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());    
    ((ExoWindowID)resourceInput.getInternalWindowID()).setPortletName("PortletToTestResourceURL");
    resourceInput.setPortletMode(PortletMode.VIEW);
    ResourceOutput o = portletContainer.serveResource(request, response, resourceInput);
    assertTrue(new String(o.getContent()).length() == 3);
    log.info("Done.");
      
  
    
    //  Uncomment for cache expiring test; testResourceURL2 must be fail when expires.
    //  Sleep time must be over than <expiration-cache> setting into portlet.xml
    
    //      try {
    //      java.lang.Thread.sleep(35000);
    //       } catch (java.lang.InterruptedException e) {
    //       }

  }
    
  public void testResourceURL2() throws PortletContainerException {
    log.info("testResourceURL2...");
    
    try{
    MockServletRequest request2 = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response2 = new MockServletResponse(new EmptyResponse());    
    ((ExoWindowID)resourceInput.getInternalWindowID()).setPortletName("PortletToTestResourceURL");
    resourceInput.setPortletMode(PortletMode.VIEW);
    ResourceOutput o2 = portletContainer.serveResource(request2, response2, resourceInput);
    assertNotNull(o2);
    String out = new String(o2.getContent());
    if (!out.equals(null))
      assertTrue(out.length() == 3);
    log.info("Done.");
    } catch (Exception ex)
    {
      ex.printStackTrace();
    }
    
  }
  
  
}
