/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp2.producer;

import org.exoplatform.services.wsrp2.type.Lifetime;
import org.exoplatform.services.wsrp2.type.RegistrationContext;
import org.exoplatform.services.wsrp2.type.RegistrationData;
import org.exoplatform.services.wsrp2.type.RegistrationState;
import org.exoplatform.services.wsrp2.type.ReturnAny;
import org.exoplatform.services.wsrp2.type.UserContext;

/**
 * @author  Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 */
public interface RegistrationOperationsInterface {
  public RegistrationContext register(RegistrationData data,
                                      Lifetime lifetime,
                                      UserContext userContext) 
    throws java.rmi.RemoteException;
  
  
  public RegistrationContext register(RegistrationData data) 
  throws java.rmi.RemoteException;
  
    
  public RegistrationState modifyRegistration(RegistrationContext context, 
                                              RegistrationData data,
                                              UserContext userContext) 
    throws java.rmi.RemoteException;
  
  
  public RegistrationState modifyRegistration(RegistrationContext context, 
                                              RegistrationData data)
  
    throws java.rmi.RemoteException;
  
    
  public ReturnAny deregister(RegistrationContext context,
                              UserContext userContext) 
    throws java.rmi.RemoteException;
  
  public ReturnAny deregister(RegistrationContext context)
  
    throws java.rmi.RemoteException;
  
  
  public Lifetime getRegistrationLifetime (RegistrationContext registrationContext, 
                                           UserContext userContext)
  throws java.rmi.RemoteException;
  
  public Lifetime setRegistrationLifetime (RegistrationContext registrationContext, 
                                             UserContext userContext, 
                                             Lifetime lifetime)
   throws java.rmi.RemoteException;
}
