/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp2.producer.impl.helpers;

import java.util.Enumeration;
import java.util.List;

import javax.portlet.PortletURL;
import javax.portlet.ResourceURL;

import org.exoplatform.services.portletcontainer.pci.PortletURLFactory;
import org.exoplatform.services.wsrp2.producer.PersistentStateManager;


/**
 * @author  Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 */
public class WSRPProducerRewriterPortletURLFactory implements PortletURLFactory{

  private String sessionID;
  private List supports;
  private String portletHandle;
  private String template;
  private boolean isCurrentlySecured;
  private String markup;
  private PersistentStateManager stateManager;

  public WSRPProducerRewriterPortletURLFactory(String markup,
                                               List supports,
                                               boolean isCurrentlySecured,
                                               String template, String portletHandle,
                                               PersistentStateManager stateManager,
                                               String sessionID) {
    this.markup = markup;
    this.supports = supports;
    this.isCurrentlySecured = isCurrentlySecured;
    this.template = template;
    this.portletHandle = portletHandle;
    this.stateManager = stateManager;
    this.sessionID = sessionID;                                  
  }

  public PortletURL createPortletURL(String type){
    return new ProducerRewriterPortletURLImp(type,
                             markup, 
                             supports,
                             isCurrentlySecured,
                             template,
                             portletHandle,
                             stateManager,
                             sessionID );    
  }
  
  public ResourceURL createResourceURL (String type) {
    return new ProducerRewriterResourceURLImp(type,
        markup, 
        supports,
        isCurrentlySecured,
        template,
        portletHandle,
        stateManager,
        sessionID );    
  }

}
