/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp2.utils;

import javax.portlet.Event;
import javax.portlet.PortletMode;

public class Events implements java.io.Serializable {
  
  private java.lang.String _value_;
  private static java.util.HashMap _table_ = new java.util.HashMap();
  
  
  //Constructor
  protected Events(java.lang.String value) {
    _value_ = value;
    _table_.put(_value_, this);
  }

  //define the events we can currently handle
  public static final java.lang.String _eventHandlingFailed = "wsrp:eventHandlingFailed";
  public static final java.lang.String _newNavigationalContextScope = "wsrp:newNavigationalContextScope";
  
  public static final Events eventHandlingFailed = new Events(_eventHandlingFailed);
  public static final Events newNavigationalContextScope = new Events(_newNavigationalContextScope);

  
  public java.lang.String getValue() {
    return _value_;
  }
  
  public static Events fromValue(java.lang.String value) {
    return (Events) _table_.get(value);
  }
  
  public static Events fromString(java.lang.String value) {
    return fromValue(value);
  }

  public boolean equals(java.lang.Object obj) {
    return (obj == this);
  }

  public int hashCode() {
    return toString().hashCode();
  }

  public java.lang.String toString() {
    return _value_;
  }

  public java.lang.Object readResolve() throws java.io.ObjectStreamException {
    return fromValue(_value_);
  }
  
  
  
  public static Events getJsrEventFromWsrpEvent(Event event) {
    if (event == null) {
      throw new IllegalArgumentException("Event must not be null.");
    }
    if (event.equals(Events.eventHandlingFailed)) {
      return eventHandlingFailed;
    } else if (event.equals(Events.newNavigationalContextScope)) {
      return newNavigationalContextScope;
    } 
    
    return eventHandlingFailed;
  }
 
  
}
